#include <stdio.h>
#include <stdlib.h>
#include <string.h>

FILE *vfp;
char *atfmname,*vtfmname,*afmname,*vfname;

FILE *vfopen();

char scaling[64];
char *progname;
int verbose = 0;

void usage(void)
{
	fprintf(stderr,"MAKEJVF ver.1.0 -- make Japanese VF file.\n");
	fprintf(stderr,"Modeified by Fukui Rei(fkr@toyoo.l.u-tokyo.ac.jp)\n");
	fprintf(stderr,"Usage: %s [ -v ] [ -s scaling ] TFMfile PSfontTFM\n", progname);
	fprintf(stderr,"Options : -v  verbose\n");
	fprintf(stderr,"          -s  scaling facter to font design size(in real number, default=1)\n");
	fprintf(stderr,"          (The value specified by -s only affects fonts mapped on character\n");
	fprintf(stderr,"          codes from 0x3021)\n");
	fprintf(stderr,"Examples : %s min10 rml \n", progname);
	fprintf(stderr,"           %s -s 1.07 hojo10 rml \n", progname);
	exit(1);
}

main(argc,argv)
int argc;
char **argv;
{
	int i,j;
	FILE *afp;
	char nbuff[256];

	progname = argv[0];

	while (--argc > 0) {
		if (**++argv == '-') {
			if (*(*argv+1) == 's') {
				if (*++argv == NULL) usage();
				argc--;
				strcpy(scaling, *argv);
			}
			else if (*(*argv+1) == 'v') {
				verbose = 1;
			}
		}
		else {
			if (*argv == NULL) usage();
			atfmname = strdup(*argv++);
			if (*argv == NULL) usage();
			vtfmname = strdup(*argv);
			break;
		}
	}

	if (atfmname == NULL || vtfmname == NULL) usage();

	vfname = strdup(atfmname);
	for (i = strlen(vfname)-1 ; i >= 0 ; i--) {
		if (vfname[i] == '/') {
			vfname = &vfname[i+1];
			break;
		}
	}
	if (!strcmp(&vfname[strlen(vfname)-4],".tfm")) {
		vfname[strlen(vfname)-4] = '\0';
	}
	strcpy(nbuff, vfname);
	vfname = nbuff;
	strcat(vfname,".vf");

	if (!strcmp(&vtfmname[strlen(vtfmname)-4],".tfm")) {
		vtfmname[strlen(vtfmname)-4] = '\0';
	}

	tfmget(atfmname);

	maketfm(vtfmname);

	vfp = vfopen(vfname);

	for (i=0;i<94;i++)
		for (j=0;j<94;j++)
			writevf((0x21+i)*256+(0x21+j),vfp);

	vfclose(vfp);

	exit(0);
}
