#include <stdio.h>
#include <stdlib.h>
#include <ctype.h>
#include "write.h"

extern char *vtfmname;
extern int unit,zw,jfm_id;
extern char scaling[], *progname;
extern int verbose;

int get_scaling(int *co, int *coi, int *coii, int *coiii)
{
	char *p, *q, numbuf[32];

	if (!scaling[0]) return;

	*co = *coi = *coii = *coiii = 0;

	p = scaling;
	while (*p) {
		if (!isdigit(*p) && *p != '.') {
			fprintf(stderr,"%s: %s: Scaling must be a positive real number!\n",
					progname, scaling);
			exit(1);
		}
		p++;
	}
	p = scaling; q = numbuf;
	if (*p == '.')	*co = 0;
	else {
		while (isdigit(*p)) *q++ = *p++; *q = '\0';
		*co = atoi(numbuf);
		if (*p != '.') return;
	}
	p++;
	if (*p && isdigit(*p)) {
		numbuf[0] = *p++; numbuf[1] = '\0'; *coi = atoi(numbuf);
	}
	else return;
	if (*p && isdigit(*p)) {
		numbuf[0] = *p++; numbuf[1] = '\0'; *coii = atoi(numbuf);
	}
	else return;
	if (*p && isdigit(*p)) {
		numbuf[0] = *p++; numbuf[1] = '\0'; *coiii = atoi(numbuf);
	}
	else return;

	return;
}


FILE *vfopen(name)
char *name;
{
	FILE *fp;
	int zwf, zwff, zwfff;
	int co, coi, coii, coiii;
	int font_id;
#if defined(JISX0212) || defined(KSC5601)
	int i;
	char VFname[32], str[32], *VFp;

	strcpy(VFname, ACTUAL_FONT_NAME); VFp = VFname;
	while (*VFp) VFp++;
#endif

	zwf = zw/10; zwff = zw/100; zwfff = zw/1000;
	co = 1; coi = coii = coiii = 0;
#ifdef JISX0212
	coii = 7; /* default value for HeiseiMin-W3-G??.mf */
#endif
#ifdef KSC5601
	coii = 4; coiii = -1; /* default value for wsmsj?.mf */
#endif
	get_scaling(&co, &coi, &coii, &coiii);

	fp = fopen(name,"w");
	if (fp == NULL) {
		fprintf(stderr,"I cannot create VF file, %s.",name);
		exit(-1);
	}

	fputc(247,fp); /* PRE */
	fputc(202,fp); /* ID */
	fputc(0,fp); /* comment size */
	fputnum(0,4,fp); /* TFM check sum */
	fputnum(10*(1<<20),4,fp); /* TFM design size */

	fputc(243,fp); /* fnt_def1 */
#if defined(JISX0212) || defined(KSC5601)
	font_id = 0;
#else
	font_id = 1; /* original */
#endif
	fputc(font_id,fp); /* Font ID */
	fputnum(0,4,fp); /* TFM check sum */
	fputnum(zw,4,fp); /* font design size (scaled) */
	fputnum(10*(1<<20),4,fp); /* font design size */
	fputc(0,fp); /* directory length */
	fputc(strlen(vtfmname),fp); /* fontname length */
	fputstr(vtfmname,strlen(vtfmname),fp); /* directory + fontname */
	if (verbose) fprintf(stderr, "Font ID %d = %s\n", font_id, vtfmname);

#if defined(JISX0212) || defined(KSC5601)
	for (i = FONTNUM_START; i <= FONTNUM_LAST; i++) {
		fputc(243,fp); /* fnt_def1 */
		font_id = i-FONTNUM_START+1;
		fputc(font_id,fp); /* Font ID */
		fputnum(0,4,fp); /* TFM check sum */
/*		fputnum(zw,4,fp); /* font design size (scaled) */
		fputnum(co*zw+coi*zwf+coii*zwff+coiii*zwfff,4,fp); /* ditto,adjusted */
		fputnum(10*(1<<20),4,fp); /* font design size */
		fputc(0,fp); /* directory length */
		sprintf(str, FONTNUM_FORMAT, i);
		strcpy(VFp, str);
		fputc(strlen(VFname),fp); /* fontname length */
		fputstr(VFname,strlen(VFname),fp); /* directory + fontname */
		if (verbose) fprintf(stderr, "Font ID %d = %s\n", font_id, VFname);
	}
#endif

	return fp;
}

writevf(code,fp)
int code;
FILE *fp;
{
	int w,skip=0;
	int dvi_bytes;
#if defined(JISX0212) || defined(KSC5601)
	static int char_code = CHAR_START;
	static int font_code = 1;
	static int char_total = 0;
#endif

	w = jfmread(code);

#if defined(JISX0212) || defined(KSC5601)
	if (code >= 0x3021) {
		char_total++;
		if (char_total > CHARNUM_TOTAL) return;
		dvi_bytes = 3;
	}
	else
		dvi_bytes = DEFAULT_DVI_BYTES;
#else
	dvi_bytes = 3;
#endif

	fputc(242,fp); /* long_char */

	switch (code) {
	case 0x2146: /*  */
	case 0x2148: /*  */
	case 0x214a: /*  */
	case 0x214c: /*  */
	case 0x214e: /*  */
	case 0x2150: /*  */
	case 0x2152: /*  */
	case 0x2154: /*  */
	case 0x2156: /*  */
	case 0x2158: /*  */
	case 0x215a: /*  */
		skip = -(zw-w);
		fputnum(dvi_bytes+1+numcount(skip),4,fp);
		break;
	case 0x2121: /* spc */
	case 0x2122: /*  */
	case 0x2123: /*  */
	case 0x2124: /*  */
	case 0x2125: /*  */
	case 0x212b: /*  */
	case 0x212c: /*  */
	case 0x2147: /*  */
	case 0x2149: /*  */
	case 0x214b: /*  */
	case 0x214d: /*  */
	case 0x214f: /*  */
	case 0x2151: /*  */
	case 0x2153: /*  */
	case 0x2155: /*  */
	case 0x2157: /*  */
	case 0x2159: /*  */
	case 0x215b: /*  */
	case 0x216b: /*  */
	case 0x216c: /*  */
	case 0x216d: /*  */
		fputnum(dvi_bytes,4,fp);
		break;
	default:
		if (w != zw) {
			skip = -(zw-w)/2;
			fputnum(dvi_bytes+1+numcount(skip),4,fp);
		}
		else {
			fputnum(dvi_bytes,4,fp);
		}
		break;
	}

	fputnum(code,4,fp); /* char code */
	fputnum(w,4,fp); /* char width */

#if defined(JISX0212) || defined(KSC5601)
	if (code >= 0x3021) {
		if (verbose)
			fprintf(stderr, "Virtual code 0x%X (font ID %d, code 0x%X) written\n",
					code, font_code, char_code);
		fputc(171+font_code,fp); /* fnt_num_x */
		fputc(128,fp); /* SET1 */
		fputc(char_code,fp); /* char code */
		char_code++;
#ifdef JISX0212
		if (char_code == 127) char_code++; /* char number 127 is skipped */
#endif
		if (char_code > CHAR_LAST) {
			char_code = CHAR_START;
			font_code++;
		}
	}
	else {
		if (verbose)
			fprintf(stderr, "Virtual code 0x%X written\n", code);
		if (skip != 0) {
			fputc(143+numcount(skip)-1,fp); /* RIGHT */
			fputnum2(skip,fp);
		}
		fputc(171,fp); /* fnt_num_0 */
		fputc(129,fp); /* SET2 */
		fputnum(code,2,fp); /* char code */
	}
#else
	if (verbose)
		fprintf(stderr, "Virtual code 0x%X written\n", code);
	if (skip != 0) {
		fputc(143+numcount(skip)-1,fp); /* RIGHT */
		fputnum2(skip,fp);
	}
	fputc(129,fp); /* SET2 */
	fputnum(code,2,fp); /* char code */
#endif
}

int vfclose(fp)
FILE *fp;
{
	int i,cc;

    cc = ftell(fp);
    for (i = 0 ; i < 4-(cc%4) ; i++) {
        fputc(248,fp); /* POST */
	}
	fclose(fp);
}

int maketfm(name)
char *name;
{
	char nbuf[256];
	FILE *fp;

	strcpy(nbuf,name);
	strcat(nbuf,".tfm");
	fp = fopen(nbuf,"w");
	if (fp == NULL) {
		fprintf(stderr,"I cannot create TFM file, %s.",name);
		exit(-1);
	}

	fputnum(jfm_id,2,fp); /* JFM ID */
	fputnum(1,2,fp); /* number of char type */
	fputnum(27,2,fp); /* file words */
	fputnum(2,2,fp); /* header words */
	fputnum(0,2,fp); /* min of char type */
	fputnum(0,2,fp); /* max of char type */
	fputnum(2,2,fp); /* width words */
	fputnum(2,2,fp); /* height words */
	fputnum(2,2,fp); /* depth words */
	fputnum(1,2,fp); /* italic words */
	fputnum(0,2,fp); /* glue/kern words */
	fputnum(0,2,fp); /* kern words */
	fputnum(0,2,fp); /* glue words */
	fputnum(9,2,fp); /* param words */

	fputnum(0,4,fp); /* check sum */
	fputnum(10*(1<<20),4,fp); /* design size */

	fputnum(0,2,fp); /* char code */
	fputnum(0,2,fp); /* char type */

	fputnum((1<<24)+(1<<20)+(1<<16),4,fp); /* char info */
	fputnum(0,4,fp); /* width */
	fputnum(1<<20,4,fp); /* width */
	if (jfm_id == 11) {
		fputnum(0,4,fp); /* height */
		fputnum((int)((1<<20)*0.9),4,fp); /* height */
		fputnum(0,4,fp); /* depth */
		fputnum((1<<20)-(int)((1<<20)*0.9),4,fp); /* depth */
	}
	else {
		fputnum(0,4,fp); /* height */
		fputnum(1<<19,4,fp); /* height */
		fputnum(0,4,fp); /* depth */
		fputnum(1<<19,4,fp); /* depth */
	}
	fputnum(0,4,fp); /* italic */

	fputnum(0,4,fp); /* tan */
	fputnum(0,4,fp); /* kanjiskip */
	fputnum(0,4,fp); /* +kanjiskip */
	fputnum(0,4,fp); /* -kanjiskip */
	fputnum(1<<20,4,fp); /* zh */
	fputnum(1<<20,4,fp); /* zw */
	fputnum(0,4,fp); /* xkanjiskip */
	fputnum(0,4,fp); /* +xkanjiskip */
	fputnum(0,4,fp); /* -xkanjiskip */

	fclose(fp);
}
